//+------------------------------------------------------------------+
//|                                               LaguerreFilter.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
#property indicator_chart_window

#property  indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Red

extern double             gamma      = 0.7;
extern ENUM_APPLIED_PRICE Price_Type = 4; 
extern ENUM_TIMEFRAMES    TimeFrame  = PERIOD_CURRENT;


double Filter[];
double Fir[];
double price[];
double L0[];
double L1[];
double L2[];
double L3[];
string IndicatorFileName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
	SetIndexLabel(0, "LaguerreFilter");
	SetIndexLabel(1, "FIR");
	SetIndexBuffer(0, Filter);
	SetIndexBuffer(1, Fir);
	SetIndexBuffer(2, price);
   SetIndexBuffer(3, L0);
   SetIndexBuffer(4, L1);
   SetIndexBuffer(5, L2);
   SetIndexBuffer(6, L3);
      TimeFrame = MathMax(TimeFrame,_Period);
      IndicatorFileName = WindowExpertName();
      IndicatorShortName("LaguerreFilter(" + DoubleToStr(gamma, 2) + ") "+(string)TimeFrame);
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   if (TimeFrame != Period())
   {
      limit = MathMin(MathMax(limit,TimeFrame/Period()),Bars-1);
      for (int i=limit; i>= 0; i--)
      {
               int y = iBarShift(NULL,TimeFrame,Time[i]);	
               Filter[i] = iCustom(NULL,TimeFrame,IndicatorFileName,gamma,Price_Type,0,y);
               Fir[i]    = iCustom(NULL,TimeFrame,IndicatorFileName,gamma,Price_Type,1,y);
      }
      return(0);         
   }

   //
   //
   //
   //
   //

	for (i=limit; i>=0; i--)
	{
		price[i]=iMA(NULL,0,1,0,0,Price_Type,i);
		   L0[i] = (1.0 - gamma)*price[i] + gamma*L0[i+1];
		   L1[i] = -gamma*L0[i] + L0[i+1] + gamma*L1[i+1];
		   L2[i] = -gamma*L1[i] + L1[i+1] + gamma*L2[i+1];
		   L3[i] = -gamma*L2[i] + L2[i+1] + gamma*L3[i+1];
		
			Filter[i] = (L0[i] + 2 * L1[i] + 2 * L2[i] + L3[i]) / 6.0;
         Fir[i]   = (price[i]+2.0*price[i+1]+2.0*price[i+2]+price[i+3]) / 6.0;
	}
   return(0);
}
//+------------------------------------------------------------------+